<script lang="ts">
// 声明额外的选项
export default {
  name: "ApiGroup"
};
</script>
<script setup lang="ts">
import { provide } from "vue";
import { useApiGroup } from "./hook";
import { http } from "@/utils/http";
import { useRenderIcon, hasAuth, PureTableBar } from "@/utils/importUsed"
import Add from "./components/add/index.vue";
import EditUpdate from "./components/update/index.vue";
import Search from "@iconify-icons/ep/search";
import Addicon from "@iconify-icons/ep/document-add";
import Delete from "@iconify-icons/ep/delete";
import EditPen from "@iconify-icons/ep/edit-pen";
import More from "@iconify-icons/ep/more-filled";

const {
  form,
  loading,
  columns,
  dataList,
  pagination,
  onSearch,
  handleSizeChange,
  handleCurrentChange,
  handleSelectionChange,
  ruleFormRef,
  handleAdd,
  addVisible,
  handleUpdate,
  editUpdateVisible,
  editUpdateFormData,
  handleDelete,

} = useApiGroup();
// 关闭添加
const closeAddVisible = () => {
  onSearch(ruleFormRef.value);
  addVisible.value = false;
}
provide('closeAddVisible', closeAddVisible)
// 关闭修改
const closeEditUpdateVisible = () => {
  onSearch(ruleFormRef.value);
  editUpdateVisible.value = false
}
provide('closeEditUpdateVisible', closeEditUpdateVisible)

</script>

<template lang="pug">
.main
  div
    //- 搜索表格组件条件
    el-form.bg-bg_color.pl-8.pt-4.pr-8(
      label-position="left"
      label-width="100px"
      :inline="true",
      :model="form",
      class="w-[99/100]"
      ref="ruleFormRef"
      :rules="rules"
    )
      el-form-item(label='名称' prop="groupName")
        el-input(v-model='form.groupName' autocomplete='off'
          placeholder="请输入名称")

      el-form-item
        el-button(
          type="primary",
          :icon="useRenderIcon(Search)",
          :loading="loading",
          @click="onSearch(ruleFormRef)"
        ) 查询
    //- 表格组件
    PureTableBar(title="api接口分组", @refresh="onSearch(ruleFormRef)" )
      template(#buttons)
        el-button(type="primary" :icon="useRenderIcon(Addicon)" @click="handleAdd()" v-if="hasAuth(['add'])") 新增

      template(v-slot="{ size, checkList }")
        pure-table( 
          row-key="id"
          ref="tableRef"
          adaptive
          align-whole="center"
          table-layout="auto"
          :loading="loading"
          :size="size",
          :data="dataList",
          :columns="columns",
          :checkList="checkList",
          :pagination="pagination",
          :paginationSmall="size === 'default' ? true : false",
          :header-cell-style="{ background: 'var(--el-table-row-hover-bg-color)', color: 'var(--el-text-color-primary)' }",
          @selection-change="handleSelectionChange",
          @size-change="handleSizeChange",
          @current-change="handleCurrentChange"
        )
          template(#operation="{ row }")
            el-button.reset-margin(
              link
              type="primary"
              size="small"
              @click="handleUpdate(row)"
              :icon="useRenderIcon(Delete)"
              v-if="hasAuth(['update'])"
            ) 编辑
            el-button.reset-margin(
              link
              type="primary"
              size="small"
              @click="handleDelete(row)"
              :icon="useRenderIcon(Delete)"
              v-if="hasAuth(['delete'])"
            ) 删除

            el-dropdown(trigger="click", :hide-on-click="false")
              el-button.ml-3(class="mt-[2px]" link type='primary' :size='size' :icon='useRenderIcon(More)')
              template(#dropdown)
                el-dropdown-menu

    Add(:addVisible="addVisible")
    EditUpdate(:editVisible="editUpdateVisible" :formData="editUpdateFormData")

                    
</template>

<style scoped lang="scss">
:deep(.el-dropdown-menu__item i) {
  margin: 0;
}

:deep(.el-form-item__label) {
  font-weight: 700;
}

:deep(.el-pagination) {
  flex-flow: wrap;
}

:deep(.is-draggable) {
  max-height: 80vh;
  overflow: auto;
}

:deep(.el-dialog__header) {
  position: sticky;
  top: 0;
  z-index: 2;
  background: #fff;
}

:deep(.el-descriptions__header) {
  margin: 16px 0 !important;
}
</style>